/*
 *  writefile.c	DCM Wood  93/03/15
 *
 *  Output file for fig (or xfig)
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <netdb.h>
#include <netinet/in.h>

#include "js2fig.h"
#include "jsdb.h"

struct Qent {
	struct Tnode * Tnode;
	struct Qent * next;
	};

extern	struct Qent * Qin;
extern	struct Qent * Qout;

extern			enFIFO();
extern	struct Qent *	deFIFO();

int	yd = 6;


/*
 *  PrintNode
 *	Send Node to the output file
 */

PrintNode( tnp )
struct Tnode * tnp;
{
    int     i;
    struct in_addr inaddr;
    struct Node * inp;
    char *  n;
    char    name[64];
    u_long  sn;
    char    substr[20];
    struct Tnode * xp;
    int     xc, yc;
    int     xl, xr, yt, yb;
    int     xx;

    xc = tnp->Xcoord;
    yc = tnp->Ycoord;
    yt = yc + yd;
    yb = yc - yd;
    xl = xc - 2 * yd;
    xr = xc + 2 * yd;

    switch ( tnp->Datap->ntype )
	{
	case NTYPE_INTF:  /*  was NTYPE_GATEWAY  */
	    fprintf( stdout,
		    "1 1 0 1 0 0 0 1 0.000 1 0.000 %d %d %d %d %d %d %d %d\n",
		    xc,  yc,
		    2 * yd,  yd,
		    xc,  yc,
		    xc + 2 * yd,  yc + yd );
	    n = NULL;
	    if ( tnp->Datap->name != NULL )
		n = tnp->Datap->name;
	    else
		{
		for ( inp=tnp->Datap->nxtintfp; inp!=NULL; inp=inp->nxtintfp )
		    if ( ( n = inp->name ) != NULL )
			break;
		}
	    if ( n != NULL )
		{
		for ( i=0; ( n[i] != '\0' ) && ( n[i] != '-' ); i++ )
		    if ( n[i] == '.' )
			break;

		    else
		        name[i] = n[i];

		name[i] = '\0';
	        fprintf( stdout, "4 1 0 10 0 0 0 0.000 4 %d %d %d %d %s\01\n",
			2 * yd,  xr -xl,  xc, yt - 2, name );
		}
	    break;

	case NTYPE_SUBNET:
/*
	    if ( tnp->FirstChild != NULL )
		{
		xl = tnp->FirstChild->Xcoord - 2 * yd;
		xx = tnp->FirstChild->Xcoord + 2 * yd;
		xr = xr < xx ? xx : xr;
		xp = tnp->FirstChild->RightSibling;
		for ( ; xp != NULL; xp = xp->RightSibling )
		    xr = xp->Xcoord + 2 * yd;
		}
 */

	    fprintf( stdout, "2 2 0 1 0 0 0 1 0.000 0 0 0\n" );
	    fprintf( stdout,
		    "\t %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d 9999 9999\n",
		    xr, yb,  xl, yb,  xl, yt,  xr, yt,  xr, yb );
/*
	    inaddr.s_addr = tnp->Datap->addr;
	    substr = (char *)inet_ntoa( inaddr );
 */
	    sn = tnp->Datap->addr >> 8 & 0xff;
	    sprintf( substr, "%d", sn );
	    fprintf( stdout, "4 1 0 10 0 0 0 0.000 4 %d %d %d %d %s\01\n",
			2 * yd,  xr -xl,  xc, yt - 2, substr );
	    break;

	}

    /*  Draw the lines between the nodes  */

    for ( xp = tnp->FirstChild; xp != NULL; xp = xp->RightSibling )
	{
	fprintf( stdout, "2 1 0 1 0 3 1 0.000 0 0 0\n" );
	/* fprintf( stdout, "\t %4d %4d %4.0f %4.0f 9999 9999\n", */
	fprintf( stdout, "\t %4d %4d %4d %4d 9999 9999\n",
			xc,  yc,   xp->Xcoord,  xp->Ycoord );
	}

    return;
}


/*
 *  OutputFile
 *	Main program
 */

OutputFile( ttnp )
struct Tnode * ttnp;
{
    struct Qent * rqep;
    struct Tnode * tnp;

    fprintf( stdout, "#FIG 2.1\n" );
    fprintf( stdout, "80 2\n" );

    enFIFO( ttnp );

    while ( 1 )
	{
	rqep = deFIFO();
	if ( rqep == NULL )
	    break;

	tnp = rqep->Tnode;
	if ( tnp == NULL )
	    continue;


	for ( ; tnp != NULL; tnp = tnp->RightSibling )
	    {
	    PrintNode( tnp );
	    if ( tnp->FirstChild != NULL )
		enFIFO( tnp->FirstChild );
	    }
	}

    return;
}

