/*
 *  jsdb.h	DCM Wood  93/04/03
 */

#define  HASH_TABLE_SIZE  512

/*
#ifndef  TRUE
#define  TRUE  1
#endif

#ifndef  FALSE
#define  FALSE 0
#endif
 */

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN  64
#endif

#define  NTYPE_NET	1
#define  NTYPE_SUBNET	2
#define  NTYPE_INTF	3
#define  NTYPE_GATEWAY	4
#define  NTYPE_NXTLVL	5
#define  MAX_NTYPE	6


struct Node {
	u_long		addr;		/* IP address */
	u_long		sm;		/* Subnet mask */
	char *		name;		/* interface name */
	u_char		eaddr[6];	/* Ethernet address */
	short		rtype;		/* Record Type */
	short		ntype;		/* Node type */
	short		icount;		/* Count of interfaces below this */
	short		scount;		/* Count of subnets below this net */
	struct list *	gwlp;		/* Gateway list pointer */
	struct list *	snlp;		/* Subnet list pointer */
	struct Node *	nxtintfp;	/* Next interface on same GW */
	int		CreationTime;
	struct Node *	gwp;		/* GW to which this intf belongs */
	struct Node *	Next;		/* next Node of same type */
	struct Node *	SameHash;	/* next Node with same hash */
#ifndef TNODE
	int *		tnp;
#else
	struct Tnode *	tnp;		/* Must be defined elsewhere */
#endif
#ifndef BTN
	int *		bp;
#else
	struct Btn *	bp;		/* Must be defined elsewhere */
#endif
	};

struct list {
	struct Node * node;
	struct list * next;
	};

struct NameEnt {
	char *	name;
	struct Node * intfp;
	struct NameEnt * Next;
	struct NameEnt * SameHash;
	};

/*
 * struct Tnode {
 *	struct Tnode *	Parent;
 *	struct Tnode *	FirstChild;
 *	struct Tnode *	LeftSibling;
 *	struct Tnode *	RightSibling;
 *	int		Xcoord;
 *	int		Ycoord;
 *	int		Prelim;
 *	int		Modifier;
 *	struct Tnode *	LeftNeighbor;
 *	struct Node  *	Datap;
 *	};
 */


#ifdef MAIN

struct Node * SNHT[HASH_TABLE_SIZE];
struct Node * GWHT[HASH_TABLE_SIZE];
struct Node * INHT[HASH_TABLE_SIZE];
struct NameEnt * NAHT[HASH_TABLE_SIZE];

char *	jshostp;
char	hostname[64];

struct Node *	NHT[HASH_TABLE_SIZE];

int	IRCnt;			/* Count of Interface records read */
int	IFCnt;			/* Count of Interface entries created */
int	GRCnt;			/* Count of Gateway records read */
int	GWCnt;			/* Count of Gateway Entries created */
int	SNCnt;			/* Count of Subnet Entries created */
int	NameCnt;		/* Count of Name entries created */
int	NetCnt;			/* Count of Networks encountered */
int	NRCnt;			/* Count of Network records read */

struct Node * fp[MAX_NTYPE];	/* Linked list of nodes by ntype */
struct Node * lp[MAX_NTYPE];

struct NameEnt * NaFirst=NULL;		/* Linked list of names  */
struct NameEnt * NaLast=NULL;

#else  /* MAIN */

extern	struct Node * SNHT[];
extern	struct Node * GWHT[];
extern	struct Node * INHT[];
extern	struct NameEnt * NAHT[];

extern	char *	jshostp;
extern	char	hostname[];

extern	struct Node *	NHT[];

extern	int	IRCnt;		/* Count of Interface records read */
extern	int	IFCnt;		/* Count of Interface entries created */
extern	int	GRCnt;		/* Count of Gateway records read */
extern	int	GWCnt;		/* Count of Gateway Entries created */
extern	int	SNCnt;		/* Count of Subnet Entries created */
extern	int	NameCnt;	/* Count of Name entries created */
extern	int	NetCnt;		/* Count of Networks encountered */
extern	int	NRCnt;		/* Count of Network records read */

extern	struct Node * fp[];	/* Linked list of nodes by ntype */
extern	struct Node * lp[];

extern	struct NameEnt * NaFirst;	/* Linked list of names  */
extern	struct NameEnt * NaLast;

#endif /* MAIN */

