/*
 *  readjs.c	DCM Wood  93/03/09
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <strings.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/types.h>

#include <netdb.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>

#include "sniff.h"
#include "js.h"

int	jsfd;
FILE *	jsfp;

static	int	lines = 0;


/*
 *  WriteAddr
 */

WriteAddr( addr, eaddr )
u_long	addr;
u_char * eaddr;
{
    struct in_addr inaddr;

    if ( lines == 0 )
	printf( "station \"Broadcast\" = ffffffffffff\n" );
    lines++;

    inaddr.s_addr = addr;
    printf( "station \"%s\" = %02x%02x%02x%02x%02x%02x\n", inet_ntoa( inaddr ),
		eaddr[0], eaddr[1], eaddr[2], eaddr[3], eaddr[4], eaddr[5] );
    return;
}


/*
 *  WriteLine
 */

WriteLine( name, eaddr )
char *	name;
u_char * eaddr;
{
    int     i;
    char    nbuf[64];

    if ( lines == 0 )
	printf( "station \"Broadcast\" = ffffffffffff\n" );

    lines++;
    for ( i=0; i<64; i++ )
	if ( ( name[i] != '.' ) && ( name[i] != '\0' ) )
	    nbuf[i] = name[i];
	else
	    break;

    nbuf[i] = '\0';
    printf( "station \"%s\" = %02x%02x%02x%02x%02x%02x\n", nbuf,
		eaddr[0], eaddr[1], eaddr[2], eaddr[3], eaddr[4], eaddr[5] );
    return;
}


/*
 *  ReadStuff
 *	Read information from Journal Server
 */

ReadStuff()
{
    short   buf = GET_EADDR;
    int     cc;
    int     end;
    int     i;
    struct jsNode * jsnp;

    if ( debug )
	printf( " Reading stuff from the Journal Server\n" );

    jsfd = JSconnect( jshostp, QUERY_PORT );

    cc = write( jsfd, &buf, sizeof(short) );
    if ( cc != sizeof(short) )
	{
	perror( "sniff: ReadStuff" );
	close( jsfd );
	exit( 1 );
	}

    jsfp = fdopen( jsfd, "r" );

    end = 0;
    while ( ! end )
	{
	jsnp = GetNextRecord( jsfp );
	if ( jsnp == NULL )
	    break;

	switch ( jsnp->rtype )
	    {
	    case NETWORK:
		break;

	    case GATEWAY:
		break;

	    case INTF:
/*
 *		for ( i=0; i<6; i++ )
 *		    if ( jsnp->eaddr[i] != 0 )
 *			break;
 *
 *		if ( ( i < 6 ) && ( jsnp->name != NULL ) )
 *		    {
 *		    WriteLine( jsnp->name, jsnp->eaddr );
 *		    if ( *(int *)jsnp->eaddr == 0 )
 *			printf( "\t\t Zero Ethernet address\n" );
 *		    }
 *		else
 *		    if ( *(int *)jsnp->eaddr != 0 )
 *			{
 *			printf( "\t\t Non-zero Ethernet address\t" );
 *			WriteLine( jsnp->name, jsnp->eaddr );
 *			}
 */
		if ( *(int *)jsnp->eaddr != 0 )
		    {
		    if ( jsnp->name != NULL )
			WriteLine( jsnp->name, jsnp->eaddr );
		    else
		    if ( jsnp->addr != 0 )
			WriteAddr( jsnp->addr, jsnp->eaddr );
		    }
		break;

	    default:
		end++;
	    }
	}
    fclose( jsfp );
}

