
/*
 *  snm_prog.c
 */

#include<stdio.h>

#define SOCKADDR_IN
#include<data_server.h>
#include<send_data.h>

#include"snm.h"

char *data_store[] = {
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
};

FILE *snm_file;


main()
{
    struct data_list *gateways;
    struct data_list *get_gateway();
    void name_host();

    init_database();
    gateways = get_gateway(NULL);

    store_gateways(gateways);


    list_walk(data_store[GATEWAY],name_host);

    if((snm_file = fopen("snm_data","w+")) == NULL)
	{
	printf("Unable to open snm file\n");
	exit(1);
	}

    list_print(data_store[GATEWAY]);
    list_print(data_store[NETWORK]);


}


init_database()
{
    void print_gateway();
    void print_network();
    data_store[GATEWAY] = (char *)list_init(NULL,NULL,print_gateway);
    data_store[NETWORK] = (char *)list_init(NULL,NULL,print_network);
}


store_gateways(data)
struct data_list *data;
{
    struct data_list *current_data = data;
    static char *subnet_last_node = NULL;
    static char *gateway_last_node = NULL;
    struct addr_table *store_octet();

    while(current_data)
	{
	struct data_record *gw_data;

	gw_data = current_data->data;

	if(gw_data->dr_type.gateway->intfs)
	    {
	    struct intf_list *interfaces;
	    interfaces = gw_data->dr_type.gateway->intfs;
	    while(interfaces)
		{
		char **root;
		u_char *tmp_addr;
		struct addr_table *tmp_node;
		root = &data_store[IN_ADDR_STORE];
		if((tmp_addr = (u_char *)malloc(4 * sizeof(u_char))) == NULL)
		    {
		    printf("Unable to allocate memory for tmp_addr\n");
		    exit(1);
		    }
		bcopy(((struct sockaddr_in *)interfaces->subnet_intf->ip_addr->pa)->sin_addr,tmp_addr,4 * sizeof(u_char));
		tmp_node = store_octet(root,tmp_addr,NULL);
		tmp_node->dir.intf_data = interfaces->subnet_intf;
		tmp_node->dir.intf_data->host = gw_data->dr_type.gateway;
		interfaces  = interfaces->next_intf;
		}
	    }
	if(gw_data->dr_type.gateway->connected_subnets)
	    {

	    struct subnet *subnets;
	    subnets = gw_data->dr_type.gateway->connected_subnets;
	    while(subnets)
		{
		int gw_pointer_not_found = 1;
		u_char *tmp_addr;
		char **root;
		struct addr_table *tmp_node;
		struct gw_pointer **gw_node;
		struct gw_pointer *gateway;

		if((tmp_addr = (u_char *)malloc(4*sizeof(u_char))) == NULL)
		    {
		    printf("Unable to allocate memory for tmp_addr\n");
		    exit(1);
		    }
		if(subnets->net_intf)
		    {
		    struct addr_table *tmp_node;
		    root = &data_store[IN_ADDR_STORE];
		    bcopy(((struct sockaddr_in *)subnets->net_intf->ip_addr->pa)->sin_addr,tmp_addr,4* sizeof(u_char));
		    tmp_node = store_octet(root,tmp_addr,NULL);
		    if(!tmp_node->dir.intf_data)
			{
			tmp_node->dir.intf_data = subnets->net_intf;
			tmp_node->dir.intf_data->host = gw_data->dr_type.gateway;
			}
		    }
		root = &data_store[SUBNET];
		bcopy(((struct sockaddr_in *)subnets->subnet_info->net_numb->pa)->sin_addr,tmp_addr,4 * sizeof(u_char));

		if((gateway = (struct gw_pointer *)malloc(sizeof(struct gw_pointer))) == NULL)
		    {
		    printf("Can't allocate space for gateway\n");
		    exit(1);
		    }
		bzero(gateway,sizeof(struct gw_pointer));
		tmp_node = store_octet(root,tmp_addr,NULL);
		if(!tmp_node->dir.subnet)
		    {
		    struct data_record *network_data;
		    tmp_node->dir.subnet = subnets->subnet_info;
		    if((network_data = (struct data_record *)malloc(sizeof(struct data_record))) == NULL)
			{
			printf("unable to allocate memory for network_data\n");
			exit(1);
			}
		    bzero(network_data,sizeof(struct data_record));
		    network_data->data_type = NETWORK;
		    network_data->dr_type.subnet = tmp_node->dir.subnet;
		    subnet_last_node = (char *)list_insert(data_store[NETWORK],subnet_last_node,network_data);
		    }
		gw_node = &tmp_node->dir.subnet->gwp_start;
		while(*gw_node)
		    {
		    struct intf_list *intfs;
		    intfs = (*gw_node)->gw_host->intfs;
		    while(intfs)
			{
			if(bcmp(((struct sockaddr_in *)gw_data->dr_type.gateway->intfs->subnet_intf->ip_addr->pa)->sin_addr,((struct sockaddr_in *)intfs->subnet_intf->ip_addr->pa)->sin_addr,4 * sizeof(u_char))  == 0)
			    {
			    gw_pointer_not_found = 0;
			    break;
			    }
			intfs = intfs->next_intf;

			}
		    gw_node = &(*gw_node)->gw_next;
		    }
		if(gw_pointer_not_found)
		    {
		    gateway->gw_host  = gw_data->dr_type.gateway;
		    *gw_node = gateway;
		    }
		subnets = subnets->next_subnet;
		}

	    }
	gateway_last_node = (char *)list_insert(data_store[GATEWAY],gateway_last_node,gw_data);
	current_data = current_data->next;
	}
}


struct addr_table *
store_octet(root,tmp_addr,return_addr)
#ifdef DEBUG
struct avl_node **root;
#else
char **root;
#endif
u_char *tmp_addr;
struct addr_table **return_addr;
{
    struct addr_table *tmp_node;
    struct addr_table *ans_data;
    int addr_compare();
    int counter;
    for(counter=0;counter< 4; counter++)
	{

	if((tmp_node = (struct addr_table *)malloc(sizeof(struct addr_table)))== NULL)
	    {
	    printf("error in allocating space for tmp_node\n");
	    exit(1);
	    }
	bzero(tmp_node,sizeof(struct addr_table));
	tmp_node->octet = *tmp_addr;
	ans_data = (struct addr_table *)avlsearch(tmp_node,addr_compare,root);
	if(!ans_data)
	    return(ans_data);
	root = (char **)&(ans_data->dir.root_next_octet);
	tmp_addr++;

	}
    if(return_addr)
	*return_addr = tmp_node;
    return(ans_data);
}


void
name_host(data)
struct data_record *data;
{
    char *tmp_gw_name;

    tmp_gw_name = (char *)inet_ntoa(((struct sockaddr_in *)data->dr_type.gateway->intfs->subnet_intf->ip_addr->pa)->sin_addr);
    data->dr_type.gateway->gw_name = (char *)strdup(tmp_gw_name);
}


void
print_gateway(data)
struct data_record *data;
{
    fprintf(snm_file,"cluster(\n");
    fprintf(snm_file,"component.router (");
    fprintf(snm_file,"%s )\n",data->dr_type.gateway->gw_name);
    fprintf(snm_file,")\n");
    fprintf(snm_file,"\n\n");
}


void
print_network(data)
struct data_record *data;
{
    struct gw_pointer *gws;
    fprintf(snm_file,"cluster(\n");
    fprintf(snm_file,"view.subnet ( ");
    fprintf(snm_file,"%s )\n",inet_ntoa(((struct sockaddr_in *)data->dr_type.subnet->net_numb->pa)->sin_addr));
    gws = data->dr_type.subnet->gwp_start;
    while(gws)
	{
	fprintf(snm_file,"connect ( %s )\n",gws->gw_host->gw_name);
	gws = gws->gw_next;
	}
    fprintf(snm_file,")\n");
    fprintf(snm_file,"\n\n");
}


int addr_compare(data1,data2)
struct addr_table *data1;
struct addr_table *data2;
{
    if(data2->octet < data1->octet)
	return(-1);
    else if(data1->octet < data2->octet)
	return(1);
    else
	return(0);
}

