/*
 *  MeanNodeSize.c
 */

/*
 *  This function return the mean size of the two passed nodes.
 *  It add the size of the right half of the left-hand node to the
 *    left half of the right-hand node.
 *  If all nodes are the same size, this is a trivial calculation.
 */

#include "PositionTree.h"

MeanNodeSize( LeftNode, RightNode )
struct node * LeftNode;
struct node * RightNode;
{
    int    NodeSize;

    NodeSize = 0;
    switch ( Orientation )
	{
	case O_NORTH:
	case O_SOUTH:
	    if ( LeftNode != NULL )
		NodeSize = NodeSize + RightSize( LeftNode );
	    if ( RightNode != NULL )
		NodeSize = NodeSize + LeftSize( RightNode );
	    break;

	case O_EAST:
	case O_WEST:
	    if ( LeftNode != NULL )
		NodeSize = NodeSize + TopSize( LeftNode );
	    if ( RightNode != NULL )
		NodeSize = NodeSize + BottomSize( RightNode );
	    break;
	}
    return( NodeSize );
}
