/*
 *  PositionTree.h
 */

#define	TRUE  1
#define	FALSE 0

#ifndef NULL
#define NULL  (struct node *)0
#endif

#define O_NORTH	1
#define O_EAST	2
#define O_SOUTH	3
#define O_WEST	4

struct node {
	struct node  *	Parent;
	struct node  *	FirstChild;
	struct node  *	LeftSibling;
	struct node  *	RightSibling;
	int		Xcoord;
	int		Ycoord;
	int		Prelim;		/* Preliminary X coordinate */
	int		Modifier;
	struct node  *	LeftNeighbor;
	int		DataPointer
	};

struct pn {
	struct node * Previous;
	struct pn * NextLevel;
	};

#ifdef MAIN

struct pn  *	LevelZeroPtr;

int	xTopAdjustment;
int	yTopAdjustment;

int	LevelSeparation=10;
int	MaxDepth=10;
int	SiblingSeparation=10;
int	SubtreeSeparation=10;

int	xLimit = 4000;
int	yLimit = 4000;

int	Nodesize = 4;
int	Orientation = O_NORTH;

#else  /* MAIN */

extern	struct pn  *	LevelZeroPtr;

extern	int	xTopAdjustment;
extern	int	yTopAdjustment;

extern	int	LevelSeparation;
extern	int	MaxDepth;
extern	int	SiblingSeparation;
extern	int	SubtreeSeparation;

extern	int	xLimit;
extern	int	yLimit;

extern	int	Nodesize;
extern	int	Orientation;

#endif /* MAIN */

#define FIRSTCHILD( Node )	( Node->FirstChild )
#define LEFTNEIGHBOR( Node )	( Node->LeftNeighbor )
#define LEFTSIBLING( Node )	( Node->LeftSibling )
#define MODIFIER( Node )	( Node->Modifier )
#define PARENT( Node )		( Node->Parent )
#define PRELIM( Node )		( Node->Prelim )
#define RIGHTSIBLING( Node )	( Node->RightSibling )
#define XCOORD( Node )		( Node->Xcoord )
#define YCOORD( Node )		( Node->Ycoord )

#define NEXTLEVEL( Pn )	( Pn->NextLevel )
#define PREVNODE( Pn )	( Pn->Previous )

#define IsLeaf( Node )		( Node->FirstChild == NULL ? 1 : 0 )
#define HasChild( Node )	( Node->FirstChild != NULL ? 1 : 0 )
#define HasLeftSibling( Node )	( Node->LeftSibling != NULL ? 1 : 0 )
#define HasRightSibling( Node )	( Node->RightSibling != NULL ? 1 : 0 )
#define LeftSize( Node )	( Nodesize / 2 )
#define RightSize( Node )	( Nodesize / 2 )
#define BottomSize( Node )	( Nodesize / 2 )
#define TopSize( Node )		( Nodesize / 2 )

