/*
 * btn.c
 */

#include <stdio.h>
#include <X11/Xlib.h>
#include <netdb.h>
#include <netinet/in.h>

#include "display.h"

#include "xjsv.h"
#include "jsdb.h"

void FlashButton();

static GC BtnGC = 0;


bHash( win )
int	win;
{
    int     hc;

    hc = win % HASH_TABLE_SIZE;
    return( hc );
}


int DoButtonPress( win )
Window win;
{
    struct Btn * bp;
    int     hc;

    if ( debug )
	printf( " DoButtonPres\n" );

    hc = bHash( win );
    bp = BHT[hc];
    while ( bp != NULL )
	{
	if ( bp->win == win )
	    {
	    FlashButton( bp );
	    if ( bp->func != NULL )
		bp->func( bp );
	    return( TRUE);
	    }
	}

    return( FALSE );
}


void FlashButton( bp )
struct Btn * bp;
{
    XSetFunction( Dp, BtnGC, GXinvert );

    XFillRectangle( Dp, bp->win, BtnGC, 0, 0, bp->width, bp->height );
    SyncDpy();

    XFillRectangle( Dp, bp->win, BtnGC, 0, 0, bp->width, bp->height );

    XSetFunction( Dp, BtnGC, GXcopy );
}


struct Btn *
CreateBtn( lable, width, height, x, y, func, np )
char *	lable;
int	width;
int	height;
int	x, y;
int	(*func)();
struct Node * np;
{
    struct Btn * bp;
    char    cbuf[64];
    int     hc;
    int     i;
    struct in_addr inaddr;
    int     len;
    int     mx, my;
    int     nx;
    int     bstart = 90;
    int     small = FALSE;

    bp = (struct Btn *)calloc( 1, sizeof( struct Btn ) );
    if ( bp == NULL )
	{
	perror( "xjsv: CreateBtn: calloc" );
	exit( -1 );
	}

    bp->state = MainLoopState;;
    if ( ( width == 0 ) && ( lable != NULL ) )
	width = ( strlen( lable ) + 2 ) * 6;
    bp->width = width;
    bp->height = height;
    bp->x = x;
    bp->y = y;
    bp->func = func;
    bp->np = np;
    bp->mapped = FALSE;
    if ( BtnOne == NULL )
	BtnOne = bp;
    else
	BtnLast->next = bp;
    BtnLast = bp;

    if( BtnGC == 0 )
	{
	BtnGC = XCreateGC( Dp, MainWin, 0, NULL );
	XSetState(Dp, BtnGC, ForGndPix, BackGndPix, GXcopy, AllPlanes);
	}

    bp->win = XCreateSimpleWindow( Dp, MainWin, x, y, width - 2,
					height - 2, 1, ForGndPix, BackGndPix );
    XSelectInput( Dp, bp->win,
			ExposureMask | StructureNotifyMask | ButtonPressMask );
    hc = bHash( bp->win );
    BHT[hc] = bp;

    if ( lable != NULL )
	{
	len = strlen( lable );
	if ( len > MAX_LABLE )
	    {
	    len = MAX_LABLE;
	    strncpy( bp->lable, lable, MAX_LABLE-1 );
	    bp->lable[MAX_LABLE-1] = '\0';
	    }
	else
	    strcpy( bp->lable, lable );

	len = strlen( bp->lable );
	mx = ( bp->width - ( len * 6 ) ) / 2;

	if( bp->height < 10 )
	    my = bp->height + ( 10 - bp->height ) / 2 - 1;
	else
	    my = bp->height / 2 + 4;

	XDrawImageString(Dp, bp->win, Text6x10GC, mx, my, bp->lable, len);
	}

    if ( MainLoopState == INDV_STATE )
	{
	DrawIndv( bp );
	return( bp );
	}

    if ( np != NULL )
	{
	np->bp = bp;
	bp->np = np;
	inaddr.s_addr = np->addr;
	strcpy( cbuf, (char *)inet_ntoa( inaddr ) );
	XDrawImageString( Dp, bp->win, Text6x10GC, 6, 10,
							cbuf, strlen( cbuf ) );
	if ( np->name != NULL )
	    {
	    for ( i=0; i<MAX_NAMEB; i++ )
		if ( np->name[i] == '.' )
		    break;
		else
		    cbuf[i] = np->name[i];
	    cbuf[i] = '\0';
	    XDrawImageString( Dp, bp->win, Text6x10GC, 100, 10, cbuf, i );
	    }
	else
	    {
	    nx = 100;
	    if ( np->scount > 0 )
		{
		sprintf( cbuf, "%5d", np->scount );
		XDrawImageString( Dp, bp->win, Text6x10GC, nx, 10, cbuf, 5 );
		nx += 6 * 6;
		}
	    if ( np->icount > 0 )
		{
		sprintf( cbuf, "%5d", np->icount );
		XDrawImageString( Dp, bp->win, Text6x10GC, nx, 10, cbuf, 5 );
		}
	    }
	}

    return( bp );
}


void ShowBtn( bp )
struct Btn * bp;
{
    XEvent ev;
    int     ql;

/*
 *  if ( bp->mapped == TRUE )
 *	return;
 */

    if ( ( bp->state != MainLoopState ) || ( bp->win == 0 ) )
	return;

    XMapWindow( Dp, bp->win );

    while( ( ql = XPending( Dp ) ) > 0 )
	{
	XNextEvent( Dp, &ev );
	/* if( ev.type == Expose )
	    break; */
	}

    bp->mapped = TRUE;
}


void HideBtn( bp )
struct Btn * bp;
{
    if ( ( bp->state != MainLoopState ) || ( bp->win == 0 ) )
	return;

    XUnmapWindow( Dp, bp->win );
    bp->mapped = FALSE;
}


void RemvBtn( bp )
struct Btn * bp;
{
    XEvent ev;
    int     ql;

    if ( ( bp->state <= 1 ) || ( bp->win == 0 ) )
	return;

    if ( bp->mapped = TRUE )
	XUnmapWindow( Dp, bp->win );

    XSelectInput( Dp, bp->win, 0 );

    while( ( ql = XPending( Dp ) ) > 0 )
	XNextEvent( Dp, &ev );

    XDestroyWindow( Dp, bp->win );

    while( ( ql = XPending( Dp ) ) > 0 )
	XNextEvent( Dp, &ev );

    XFree( (char *)bp->win );

    bp->mapped = FALSE;
    bp->win = 0;
}


void RedrawAllBtns()
{
    int i;
    struct Btn * bp;

    for( bp=BtnOne; bp!=NULL; bp=bp->next )
	{
	if ( ( bp->mapped == TRUE ) && ( bp->state == MainLoopState ) )
	    RedrawBtn( bp );
	}

}


RedrawBtn( bp )
struct Btn * bp;
{
    int     bstart = 90;
    char    cbuf[64];
    int     i;
    struct in_addr inaddr;
    int     len;
    int     mx, my;
    int     nx;
    int     small = FALSE;

    if ( ( bp->state != MainLoopState ) ||
		       ( bp->win == 0 ) ||
		( bp->mapped == FALSE ) )
	return;

    XClearWindow( Dp, bp->win );

    if ( bp->lable != NULL )
	{
	len = strlen( bp->lable );
	mx = ( bp->width - ( len * 6 ) ) / 2;

	if( bp->height < 10 )
	    my = bp->height + ( 10 - bp->height ) / 2 - 1;
	else
	    my = bp->height / 2 + 4;

	XDrawImageString(Dp, bp->win, Text6x10GC, mx, my, bp->lable, len);
	}

    if ( MainLoopState == INDV_STATE )
	{
	DrawIndv( bp );
	return;
	}

    if ( bp->np != NULL )
	{
	inaddr.s_addr = bp->np->addr;
	strcpy( cbuf, (char *)inet_ntoa( inaddr ) );
	XDrawImageString( Dp, bp->win, Text6x10GC, 6, 10,
							cbuf, strlen( cbuf ) );

	if ( bp->np->name != NULL )
	    {
	    for ( i=0; i<MAX_NAMEB; i++ )
		if ( bp->np->name[i] == '.' )
		    break;
		else
		    cbuf[i] = bp->np->name[i];
	    cbuf[i] = '\0';
	    XDrawImageString( Dp, bp->win, Text6x10GC, 100, 10, cbuf, i );
	    }
	else
	    {
	    nx = 100;
	    if ( bp->np->scount > 0 )
		{
		sprintf( cbuf, "%5d", bp->np->scount );
		XDrawImageString( Dp, bp->win, Text6x10GC, nx, 10, cbuf, 5 );
		nx += 6 * 6;
		}
	    if ( bp->np->icount > 0 )
		{
		sprintf( cbuf, "%5d", bp->np->icount );
		XDrawImageString( Dp, bp->win, Text6x10GC, nx, 10, cbuf, 5 );
		}
	    }
	}

    return;
}

