/*
 * indv.c
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <strings.h>
#include <netdb.h>
#include <netinet/in.h>

#include "display.h"

#include "xjsv.h"
#include "jsdb.h"

extern		QuitStat();
extern	void	SetIndv();
extern	void	SetSN();

static void	ClearLabel();
static void	ExitIndv();
static void	HideIndvBtn();
static void	MakeIndvBtn();
static void	ShowIndvBtn();
static void	WipeIndvBtn();

static struct Btn * ButQuit;
static struct Btn * ButExit;
/* static Window	IndvWin; */

static int WindowWidth = 250;
static int WindowHeight = 100;

static	int	ydelta = 15;

void
DrawIndv( bp )
struct Btn * bp;
{
    char *  cp;
    int     i;
    struct in_addr inaddr;
    char *  lbl1;
    char *  lbl2;
    char *  lbl3;
    char *  lbl4;
    char *  lbl5;
    char *  lbl6;
    int     len;
    struct Node * np;
    char    scrstr[256];
    int     x, y;

    if ( debug )
	printf( " DrawIndv\n" );

    np = bp->np;
    if ( np == NULL )
	return;

    lbl1 = "    IP address:";
    lbl2 = "   Subnet Mask:";
    lbl3 = " Ethernet addr:";
    lbl4 = "Interface Name:";
    lbl5 = "   Domain Name:";
    lbl6 = "   Last Change:";

    x = 10;
    y = 10;
    len = 15;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl1, len );
    y += ydelta;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl2, len );
    y += ydelta;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl3, len );
    y += ydelta;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl4, len );
    y += ydelta;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl5, len );
    y += ydelta;
    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, lbl6, len );

    x = 110;
    y = 10;
    if ( np->addr != 0 )
	{
	inaddr.s_addr = np->addr;
	cp = inet_ntoa( inaddr );
	len = strlen( cp );
	XDrawImageString( Dp, bp->win, Text6x10GC, x, y, cp, len );
	}
    y += ydelta;
    if ( np->sm != 0 )
	{
	inaddr.s_addr = np->sm;
	cp = inet_ntoa( inaddr );
	len = strlen( cp );
	XDrawImageString( Dp, bp->win, Text6x10GC, x, y, cp, len );
	}
    y += ydelta;
    if ( (int)np->eaddr[0] != 0 )
	{
	sprintf( scrstr,  "%02x:%02x:%02x:%02x:%02x:%02x",
					np->eaddr[0],
					np->eaddr[1],
					np->eaddr[2],
					np->eaddr[3],
					np->eaddr[4],
					np->eaddr[5] );
	len = strlen( scrstr );
	XDrawImageString( Dp, bp->win, Text6x10GC, x, y, scrstr, len );
	}
    y += ydelta;
    if ( np->name != 0 )
	{
	for ( i=0; i<17; i++ )
	    if ( ( np->name[i] != '.' ) && ( np->name[i] != '\0' ) )
	        scrstr[i] = np->name[i];
	    else
		break;
	scrstr[i] = '\0';
	len = strlen( scrstr );
	XDrawImageString( Dp, bp->win, Text6x10GC, x, y, scrstr, len );
	}
    y += ydelta;
    if ( np->name != 0 )
	{
	if ( np->name[i] == '.' )
	    {
	    i++;
	    strcpy( scrstr, &np->name[i] );
	    len = strlen( scrstr ); 
	    XDrawImageString( Dp, bp->win, Text6x10GC, x, y, scrstr, len );
	    }
	}
    y += ydelta;
    if ( np->CreationTime != 0 )
	{
	}
    return;
}


void
MakeIndvDisplay()
{
    if ( debug )
	printf( " MakeIndvDisplay\n" );

    /* IndvWin = XCreateSimpleWindow( Dp, MainWin, 0, 0, 250, 7 * ydelta, 0,
						ForGndPix, BackGndPix ); */
    WindowWidth = 250;
    WindowHeight = 100;
    MakeIndvBtn();
    ResizeWindow( WindowWidth, WindowHeight );
    FlushDpy();
    return;
}


void
WipeIndvDisplay()
{
    if ( debug )
	printf( " WipeIndvDisplay\n" );

    WipeIndvBtn();
    FlushDpy();
    return;
}


void
ShowIndvWindow()
{
    if ( debug )
	printf( " ShowIndvWindow\n" );

    ResizeWindow( WindowWidth, WindowHeight );
    ShowIndvBtn();
    DrawTitle( "Individual Interface Detail" );
    FlushDpy();
    return;
}


void
HideIndvWindow()
{
    if ( debug )
	printf( " HideIndvWindow\n" );

    HideIndvBtn();
    FlushDpy();
    return;
}


static void
HideIndvBtn()
{
    struct Btn * bp;

    if ( debug )
	printf( " HideIndvBtn\n" );

    HideBtn( ButQuit );
    HideBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	HideBtn( bp );
    return;
}


static void
ShowIndvBtn()
{
    struct Btn * bp;

    if ( debug )
	printf( " ShowIndvBtn\n" );

    ShowBtn( ButQuit );
    ShowBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	ShowBtn( bp );
    return;
}


static void
ExitIndv()
{
    if ( debug )
	printf( " ExitIndv\n" );

    ReturnToMain();
    return;
}


static void
MakeIndvBtn()
{
    int     count = 0;
    int     ncol = 1;
    int     xpos = 0;
    int     ypos = 50;
    int     ysize;

    struct Btn * bp;
    int     i;
    struct Node * np;

    if ( debug )
	printf( " MakeIndvBtn\n" );

    ysize = 7 * ydelta;

    ButQuit = CreateBtn( "Quit", 0, 15, 5, 5, QuitStat, NULL );
    ButExit = CreateBtn( "Return to Interfaces", 0, 15, 54, 5, ExitIndv, NULL );

    bp = CreateBtn( NULL, 250, ysize, xpos, ypos, SetSN, NewIntf );
    ypos += ysize;
    count++;
    if ( ypos > WindowHeight )
	WindowHeight = ypos + 10;
    if ( ncol * 250 > WindowWidth )
	WindowWidth = ncol * 250 + 10;

    if ( NewIntf->gwp != NULL )
	np = NewIntf->gwp;
    else
    if ( NewIntf->nxtintfp != NULL )
	np = NewIntf->nxtintfp;

    for ( ; np!=NULL; np=np->nxtintfp )
	{
	if ( np == NewIntf )
	    continue;

	bp = CreateBtn( NULL, 250, ysize, xpos, ypos, SetSN, np );
	if( count < 5 )
	    {
	    ypos += ysize;
	    count++;
	    }
	else 
	    {
	    ncol++;
	    xpos += 250;
	    ypos = 50;
	    count = 0;
	    }
	if ( ypos > WindowHeight )
	    WindowHeight = ypos + 10;
	if ( ncol * 250 > WindowWidth )
	    WindowWidth = ncol * 250 + 10;
	}
    FlushDpy();
    return;
}




static void
WipeIndvBtn()
{
    struct Btn * bp;

    if ( debug )
	printf( " WipeIndvBtn\n" );

    RemvBtn( ButQuit );
    RemvBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	if ( bp->state == INDV_STATE )
	    RemvBtn( bp );

    FlushDpy();
    return;
}

