/*
 * subs.c
 */

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <strings.h>

#include "xjsv.h"
#include "jsdb.h"

extern		QuitStat();
extern	void	SetIntf();

static void	ExitSubs();
static void	HideSubsBtns();
static void	MakeSubsBtns();
static void	ShowSubsBtns();
static void	WipeSubsBtns();

static struct Btn * ButQuit;
static struct Btn * ButExit;

static int WindowWidth = 400;
static int WindowHeight = 100;


void MakeSubsDisplay()
{
    if ( debug )
	printf( " MakeSubsDisplay\n" );

    WindowHeight = 100;
    MakeSubsBtns();
    ResizeWindow( WindowWidth, WindowHeight );
}


void WipeSubsDisplay()
{
    if ( debug )
	printf( " WipeSubsDisplay\n" );

    WipeSubsBtns();
}


void ShowSubsWindow()
{
    char    cbuf[28];
    struct in_addr inaddr;

    if ( debug )
	printf( " ShowSubsWindow\n" );

    ResizeWindow( WindowWidth, WindowHeight );
    ShowSubsBtns();
    inaddr.s_addr = CurNet->addr;
    sprintf( cbuf, "Subnets of %s", inet_ntoa( inaddr ) );
    DrawTitle( cbuf );
}


void HideSubsWindow()
{
    if ( debug )
	printf( " HideSubsWindow\n" );

    HideSubsBtns( ButExit );
}


static void
HideSubsBtns()
{
    struct Btn * bp;

    if ( debug )
	printf( " HideSubsBtns\n" );

    HideBtn( ButQuit );
    HideBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	HideBtn( bp );

    FlushDpy();
}


static void
ShowSubsBtns()
{
    struct Btn * bp;

    if ( debug )
	printf( " ShowSubsBtns\n" );

    ShowBtn( ButQuit );
    ShowBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	{
	ShowBtn( bp );
	/* RedrawBtn( bp ); */
	}

    FlushDpy();
}


static void
ExitSubs()
{
    if ( debug )
	printf( " ExitSubs\n" );

    ReturnToMain();
}


static void
MakeSubsBtns()
{
    int ncol = 1;
    int xpos = 0;
    int ypos = 50;
    int count = 0;

    struct Btn * bp;
    int     i;
    struct Node * np;

    if ( debug )
	printf( " MakeSubsBtns\n" );

    ButQuit = CreateBtn( "Quit", 0, 15, 5, 5, QuitStat, NULL );
    ShowBtn( ButQuit );
    /* RedrawBtn( ButQuit ); */

    ButExit = CreateBtn( "Return to Networks", 0, 15, 54, 5, ExitSubs, NULL );
    ShowBtn( ButExit );
    /* RedrawBtn( ButExit ); */

    GetSubs();
    for ( i=0; i<MAX_BTNS; i++ )
	{
	np = GetNextSubNet( CurNet->addr );
	if ( np == NULL )
	    break;

	bp = CreateBtn( NULL, 200, 17, xpos, ypos, SetIntf, np );
	if( count < 50 )
	    {
	    ypos += 15;
	    count++;
	    }
	else 
	    {
	    ncol++;
	    xpos += 200;
	    ypos = 50;
	    count = 0;
	    }
	if ( ypos > WindowHeight )
	    WindowHeight = ypos + 35;
	if ( ncol * 200 > WindowWidth )
	    WindowWidth = ncol * 200 + 10;
	}
    FlushDpy();
}


static void
WipeSubsBtns()
{
    struct Btn * bp;
    int     i;
    struct Node * np;

    if ( debug )
	printf( " WipeSubsBtns\n" );

    RemvBtn( ButQuit );
    RemvBtn( ButExit );

    for ( bp=BtnOne; bp!=NULL; bp=bp->next )
	if ( bp->state == SUBS_STATE )
	    RemvBtn( bp );

    FlushDpy();
}

