/*
 *  cfio.c	92/12/04	DCM Wood
 */

/*
 *  Discovery Manager Configuration file operation
 *	getline
 *	ReadDMCF
 */

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>

#include "dm.h"

char	dmcfn[] = "dm.cf";

int	cc;
char *	cp;
FILE *	dmcfp;
struct hostent * hent;
int	i;

char	cmdline[MAXLINE];
short	family;
struct in_addr hostaddr;
char	hostaddrs[20];
char	hostname[140];
char	ic;
char	line[MAXLINE];
int	max;
int	min;
char	mname[30];
char	oc;
short	prog;
char	wf;


/*
 *  fgetline
 *	Reads dm.cf until it finds a non-blank, non-comment line or EOF
 */

char *
fgetline( bufp )
char *	bufp;
{
    char *  cp;
    int     ll;

    for (;;)
	{
	cp = fgets( bufp, MAXLINE, dmcfp );
	if ( cp == NULL )
	    return( NULL );

	if ( bufp[0] == '#' )
	    continue;

	ll = strlen( bufp );
	if ( ll <= 1 )
	    continue;

	if ( strspn( bufp, " \t\n" ) == ll )
	    continue;

	break;
	}

    return( bufp );
}


/*
 *  FillEMCF
 *	Fill in an Explorer Module entry from the History File
 */

FillEMCF( emp )
struct em * emp;
{
    emp->family = family;
    emp->prog = prog;
    emp->wf = wf;
    emp->ic = ic;
    emp->oc = oc;
    emp->min = min;
    emp->max = max;
    emp->lre = lre;
    emp->nlre = nlre;
    emp->lrdt = lrdt;
    emp->nlrdt = nlrdt;
    strcpy ( emp->lrdts, lrdts, 26 );
    strncpy ( emp->nlrdts, nlrdts, 26 );
    emp->hostaddr.s_addr = hostaddr.s_addr;
    strcpy ( emp->hostname, hostname );
    strcpy ( emp->mname, mname );
    strcpy ( emp->cmdline, cmdline );
    return;
}


/*
 *  ReadDMCF
 *	Read the Discovery Manager Configuration File
 */

ReadDMCF()
{
    struct em ** emlp;
    int   lc=0;
    char  line[MAXLINE];


    gethostname( thisname, 32 );
    fprintf( stderr, " dm running on host %s ", thisname );
    hent = gethostbyname( thisname );
    if ( hent != 0 )
	bcopy( (hent->h_addr_list[0]), &thishost.s_addr, 4 );
    fprintf( stderr, "with address %s\n", inet_ntoa( thishost ) );

    dmcfp = fopen( dmcfn, "r" );
    if ( dmcfp == NULL )
	{
	fprintf( stderr, " dm.cf not found\n" );
	fprintf( stderr, " Giving up\n" );
	exit( 1 );
	}

    cp = fgetline( line );
    if ( cp == NULL )
	{
	fprintf( stderr, " dm.cf empty\n" );
	fprintf( stderr, " Giving up\n" );
	exit( 1 );
	}

    cc = sscanf( line, "%s %d", jsac, &jsp );
    if ( cc < 2 )
	{
	fprintf( stderr, "dm.cf format problem with line:\n" );
	fputs( line, stderr );
	fprintf( stderr, " Giving up\n" );
	exit( 1 );
	}
    else
	{
	if ( isalpha( jsac[0] ) )
	    {
	    hent = gethostbyname( jsac );
	    if ( hent != 0 )
		bcopy( (hent->h_addr_list[0]), &jsa.s_addr, 4 );
	    }
	else
	    jsa.s_addr = inet_addr( jsac );
	if ( jsa.s_addr < 1 )
	    {
	    fprintf( stderr, " Format error in Journal Server address\n" );
	    fprintf( stderr, "  %s\n", jsac );
	    fprintf( stderr, " Giving up\n" );
	    exit( 1 );
	    }
	fprintf( stderr, " Journal server at %s(%d)\n",
					    inet_ntoa( jsa ), jsp );
	}

    /*  Read and fill in Explorer Module entries  */

    emlp = &emFirst;
    for ( i=0; i<EMMAX; i++ )
	{
	cp = fgetline( line );
	if ( cp == NULL )
	    break;

        DecodeEMline( line, mname, &family, &prog, &wf, &ic, &oc, &min, &max );

	cp = fgetline( cmdline );
	cmdline[strlen(cmdline)-1] = '\0';

	emp = (struct em *)calloc( 1, sizeof( struct em ) );
	emp->hostname = (char *)malloc( strlen( thisname )+1 );
	emp->lrdts = (char *)malloc( 26 );
	emp->nlrdts = (char *)malloc( 26 );
	emp->mname = (char *)malloc( strlen( mname )+1 );
	emp->cmdline = (char *)malloc( strlen( cmdline )+1 );
	FillEMCF( emp );
	emp->hostaddr.s_addr = thishost.s_addr;
	strcpy ( emp->hostname, thisname );
	emp->lrdts[0] = '\0';
	emp->nlrdts[0] = '\0';
	emp->next = NULL;
	*emlp = emp;
	emlp = &emp->next;
	emp->flags.e_status = emp->flags.u_status = 0;
	printf( " dm: Explorer Module %s read from dm.cf\n", emp->mname );
	}

    fclose( dmcfp );
    printf( "\n" );
    return;
}

