/*
 *  getintf.c  DCM Wood	93/02/07
 */

#include <stdio.h>
#include <strings.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sockio.h>
#include <sys/errno.h>

#include <net/if.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>

#include <netdb.h>

#include "dm.h"

/*
 *  GetIntf
 *	Get info for all interfaces on this system
 */

GetIntf()
{
    int     fd;
    int     host;
    int     i;
    struct ifconf  ifc;
    struct ifreq * ifreqp;
    struct in_addr inaddr;
    struct in_addr inmask;

    /* Get some memory in which to store the ifreq entries      */

    ifc.ifc_len = MAXINTERFACES * sizeof( struct ifreq );

    ifc.ifc_req = (struct ifreq *)
			calloc( MAXINTERFACES, sizeof( struct ifreq ) );

    /* Open a socket to do ioctls on.                           */

    if ( ( fd = socket( AF_INET, SOCK_DGRAM, 0 ) ) == -1 )
        {        
        perror( "socket" );
        return (-1);
        }               
                        
    /* Do the ioctl, check the result.                          */
                 
    if ( ioctl( fd, SIOCGIFCONF, &ifc) == -1 )
        {
        perror( "ioctl SIOCGIFCONF");
        close( fd );
        return (-1);
        } 

    if ( ifc.ifc_len/sizeof(struct ifreq) == 1 )
        if( debug )
	    printf( " There is only one interface on this system\n" );
    else
        if( debug )
	    printf( " There are %d interfaces on this system\n",
                                        ifc.ifc_len/sizeof(struct ifreq) );
    ifreqp = ifc.ifc_req;

    intfcnt = 0;
    for ( i=0; i<ifc.ifc_len; i+=sizeof( struct ifreq ), ifreqp++ )
	{
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inaddr.s_addr, 4 );
        if( debug )
	    printf( " %s   %-16s", ifreqp->ifr_name, inet_ntoa( inaddr ) );
	net_intf[intfcnt].addr = inaddr.s_addr;
	if ( IN_CLASSA( inaddr.s_addr ) )
	    net_intf[intfcnt].nmask = IN_CLASSA_NET;
	else
	if ( IN_CLASSB( inaddr.s_addr ) )
	    net_intf[intfcnt].nmask = IN_CLASSB_NET;
	else
	if ( IN_CLASSC( inaddr.s_addr ) )
	    net_intf[intfcnt].nmask = IN_CLASSC_NET;
	else
	    net_intf[intfcnt].nmask = 0;

        if ( ioctl( fd, SIOCGIFNETMASK, ifreqp ) == -1 )
            {
            perror( "ioctl SIOCGIFNETMASK" );
            continue;
            }
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inmask.s_addr, 4 );
        if( debug )
	    printf( "   %-16s\n", inet_ntoa( inmask ) );
	net_intf[intfcnt].smask = inmask.s_addr;
        if ( ( inaddr.s_addr & 0xff000000 ) == 0x7f000000 )
            continue;

	intfcnt++;
        }

    close( fd );
    return( 0 );
}

