/*
 *  js.c	93/01/02	DCM Wood
 */

/*
 *  Journal Server operations
 *	OpenJS		Open connection to Journal Server
 *	ReadJS		Read data from the Journal Server
 *	LinkData	Add data record to list
 *
 */

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <netinet/in.h>
#include <netdb.h>

#include "dm.h"

#include "send_data.h"
#include "data_server.h"


struct data_list * first_node[2] = { NULL, NULL };
struct data_list * last_node[2] = { NULL, NULL };	/* list last node */

int	dti;
int	jsfd = -1;
FILE *	jsfp;

/*
 *  OpenJS
 *	Open a connection to the Journal Server
 */

OpenJS( get_type )
int	get_type;
{
    char   buf[20];
    int    cc;

    jsfd = getnetconnect( jsac, QUERY_PORT );

    *((u_short *)(buf)) = htons( get_type );
    cc = write( jsfd, buf, sizeof(u_short) );

    return;
}


/*
 *  ReadIntfEnt
 *	Read an interface entry from the Journal Server
 */

struct IntfEnt *
ReadIntfEnt()
{
}


/*
 *  ReadJS
 *	Read information from the Journal Server
 */

struct data_list *
ReadJS( data_type )
int	data_type;
{
    struct data_list * dp;
    int    get_type;
    int    LinkData();
    int    n;

    switch ( data_type )
	{
	case INTF:
	    dti = 0;
	    get_type= GET_INTF;
	    break;

	case NETWORK:
	    dti = 1;
	    get_type= GET_NETWORK;
	    break;

	default:
	    fprintf( stderr, "dm: ReadJS called with data_type = %d\n",
								data_type );
	    return( NULL );
	}

    if ( first_node[dti] != NULL )
	{
	FreeDL( first_node[dti] );
	first_node[dti] = NULL;
	}

    OpenJS( get_type );

    get_data( jsfd, LinkData, 0 );

    close( jsfd );

    dp = first_node[dti];
    for ( n=0; dp!=NULL ; dp=dp->next, n++ )
	;

    fprintf( stderr, " dm: %d data records read from Journal Server\n", n );

    return( first_node[dti] );
}


/*
 *  LinkData
 *	Create a data_list structure and add it to the list of other
 *  data_list structures.  Set a pointer in the dsta-list structure
 *  to point to the data_record structure to to be saved.
 */

LinkData( data )
struct data_record * data;
{
    struct data_list * list_nodep;	/* pointer to new data_list item */

    /* create memory for a data record were sending to the data server */

    list_nodep = (struct data_list *) malloc( sizeof( struct data_list ) );
    if ( list_nodep == NULL )
	{
	printf("Unable to allocate memory for list_node\n");
	exit(0);
	}

    list_nodep->next = NULL;

    /* put pointer to the data into the node */

    list_nodep->data = data;

    if ( first_node[dti] )		/* if list already exists */
	{				    /* then add new entry to list */
	last_node[dti]->next = list_nodep;
	last_node[dti] = list_nodep;
	}
    else				/* if list does not already exist */
	first_node[dti] = list_nodep;	    /* then make new entry the list */
	last_node[dti] = list_nodep;

    return;
}

