/*
 *  arpwatch.h
 */

#define HASHSIZE 4

/* @(#)arpwatch.h	1.1 92/12/24 */

struct arp_data {
	struct ether_addr mach_address;
	struct sockaddr address;
	char *hostname;
	int count;
	};

struct hashtab {
	struct arp_data data;
	struct hashtab *next;
	};

struct cur_arps {
	struct hashtab *arp_hash;
	struct cur_arps *next;
	};

/*
 * Compare two Ethernet addresses - assumes that the two given
 * pointers can be referenced as shorts.  On architectures
 * where this is not the case, use bcmp instead.  Note that like
 * bcmp, we return zero if they are the SAME.
 */

#if defined(sun2) || defined(sun3) || defined(sun3x)

/*
 * On 680x0 machines, we can do a longword compare that is NOT
 * longword aligned, as long as it is even aligned.
 */

#define ether_cmp(a,b) ( ((short *)a)[2] != ((short *)b)[2] || \
  *((long *)a) != *((long *)b) )

#endif

#if defined(sparc)

#define ether_cmp(a,b) ( ((short *)b)[2] != ((short *)a)[2] || \
 ((short *)b)[1] != ((short *)a)[1] || ((short *)b)[0] != ((short *)a)[0] )

#endif 

#ifndef ether_cmp

#define ether_cmp(a,b) (bcmp((caddr_t)a,(caddr_t)b, 6))

#endif

