/************************************************************************
 *									*
 *	File:  ethertoa.c						*
 *									*
 *	ETHERnet address TO Ascii (and vice versa).			*
 *									*
 *	Written 08-Sep-87 by Paul E. McKenney, SRI International.	*
 *									*
 ************************************************************************/

/*
 *	$Log:	ethertoa.c,v $
 * Revision 2.0  88/09/23  18:27:40  mckenney
 * .
 * 
 */

/* @(#)ethertoa.c	1.1 92/12/26 */
/* Include files.							*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>

/* Type definitions local to this file.					*/

/* Functions exported from this file.					*/

extern int		atoether();	/* Ascii TO ETHERnet address.	*/
extern char		*ethertoa();	/* ETHERnet address TO Ascii.	*/

/* Functions local to this file.					*/

/* Variables exported from this file.					*/

/* Variables local to this file.					*/


/* Ascii TO ETHERnet address conversion.  Returns TRUE if the string	*/
/* can be converted, FALSE otherwise.  Address must be of form:		*/
/*	xx:xx:xx:xx:xx:xx						*/

int
atoether(a, ea)

	char		*a;		/* Ascii address.		*/
	struct ether_addr *ea;		/* Ethernet Address.		*/

	{
	int		o0;
	int		o1;
	int		o2;
	int		o3;
	int		o4;
	int		o5;

	if (sscanf(a, "%x:%x:%x:%x:%x:%x", &o0, &o1, &o2, &o3, &o4, &o5) != 6)
		return (0);

	ea->ether_addr_octet[0] = o0;
	ea->ether_addr_octet[1] = o1;
	ea->ether_addr_octet[2] = o2;
	ea->ether_addr_octet[3] = o3;
	ea->ether_addr_octet[4] = o4;
	ea->ether_addr_octet[5] = o5;
	return (1);
	}

/* ETHERnet address TO Ascii conversion.  Note that the returned string	*/
/* is kept in a static buffer, so copy it if you want to keep it!	*/

extern char *
ethertoa(ea)

	struct ether_addr *ea;		/* Ethernet Address.		*/

	{
	static char	addr[25];	/* ascii-ized ADDRess.		*/

	(void)sprintf(addr, "%02x:%02x:%02x:%02x:%02x:%02x",
		      ea->ether_addr_octet[0],
		      ea->ether_addr_octet[1],
		      ea->ether_addr_octet[2],
		      ea->ether_addr_octet[3],
		      ea->ether_addr_octet[4],
		      ea->ether_addr_octet[5]);
	return (addr);
	}
