/*
 *  getintf.c  DCM Wood	93/01/23
 */

#include <stdio.h>
#include <strings.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sockio.h>
#include <netdb.h>
#include <net/if.h>
#include <netinet/in.h>

extern	int	debug;

/*
 *  GetIntf
 *	Get info for all interfaces on this system
 */

u_long
GetIntf( sap, eap )
struct sockaddr_in * sap;
struct sockaddr_in * eap;
{
    u_long  addr;
    int  cc;
    int  fd;
    struct hostent * hep;
    int  i;
    struct ifconf  ifc;
    struct ifreq * ifreqp;
    struct in_addr inaddr;
    struct in_addr inmask;
    char    netname[MAXHOSTNAMELEN];
    u_long  netmask;

    /* Get some memory in which to store the ifreq entries      */

    ifc.ifc_len = 20 * sizeof( struct ifreq );

    ifc.ifc_req = (struct ifreq *)calloc( 20, sizeof( struct ifreq ) );

    /* Open a socket to do ioctls on.                           */

    if ( ( fd = socket( AF_INET, SOCK_DGRAM, 0 ) ) == -1 )
        {        
        perror( "socket" );
        return (-1);
        }               
                        
    /* Do the ioctl, check the result.                          */
                 
    if ( ioctl( fd, SIOCGIFCONF, &ifc) == -1 )
        {
        perror( "ioctl SIOCGIFCONF");
        close( fd );
        return (-1);
        } 

    if ( ifc.ifc_len/sizeof(struct ifreq) == 1 )
        if ( debug )
	    printf( " etherhostprobe: There is 1 interface on this system\n" );
    else
        if ( debug )
	    printf( " etherhostprobe: There are %d interfaces on this system\n",
                                        ifc.ifc_len/sizeof(struct ifreq) );
    ifreqp = ifc.ifc_req;
    for ( i=0; i<ifc.ifc_len; i+=sizeof( struct ifreq ), ifreqp++ )
        {
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inaddr.s_addr, 4 );
        if ( debug )
	    printf( " %s   %-16s", ifreqp->ifr_name, inet_ntoa( inaddr ) );
        if ( ioctl( fd, SIOCGIFNETMASK, ifreqp ) == -1 )
            {
            perror( "ioctl SIOCGIFNETMASK" );
            continue;
            }
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inmask.s_addr, 4 );
        if ( debug )
	    printf( "   %-16s\n", inet_ntoa( inmask ) );
        if ( ( inaddr.s_addr & 0xff000000 ) == 0x7f000000 )
            continue;

	if ( sap->sin_addr.s_addr == 0 )
	    {
	    u_long lastaddr;
	    u_long net;

	    lastaddr = ( 0xffffffff & ~(inmask.s_addr ) ) - 1;
	    net = inaddr.s_addr & inmask.s_addr;
	    sap->sin_addr.s_addr = net + 1;
	    eap->sin_addr.s_addr = net + lastaddr;
	    }
        }

    close( fd );
    return;
}

