/************************************************************************
 *									*
 *	File:  mk_udp_ncon.c						*
 *									*
 *	MaKe UDP No-CONnection socket.					*
 *									*
 *	Written by Paul E. McKenney, SRI International.			*
 *									*
 ************************************************************************/
/* @(#)mk_udp_ncon.c	1.1 92/12/26 */
/*
 *	$Log:	mk_udp_ncon.c,v $
 * Revision 2.0  88/09/23  18:28:08  mckenney
 * .
 * 
 * Revision 1.1  87/09/02  10:16:53  mckenney
 * Initial revision
 * 
 */

/* Include files.							*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <strings.h>

/* Type definitions local to this file.					*/

/* Functions exported from this file.					*/

extern int		mk_udp_ncon();	/* MaKe UDP No_CONnect. socket.	*/

/* Functions local to this file.					*/

/* Variables exported from this file.					*/

/* Variables local to this file.					*/

/* MaKe UPD No-CONnection socket.  Return file descriptor of socket.	*/
/* Returns -1 if there was a system call problem, points em to a string	*/
/* containing the system call name.					*/
/* Returns -2 if there were other problems and points em to a		*/
/* string containing a human-readable error message.			*/
/* Creates a connectionless UDP socket.					*/

extern int mk_udp_ncon(em)

	char		**em;		/* Error Message pointer.	*/

	{
	int		s;		/* Socket.			*/

	/* Create the socket, yielding a file descriptor we can do I/O	*/
	/* on and connect to.						*/

	if ((s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
		{
		*em = "socket";
		return (-1);
		}

	return (s);
	}
