/************************************************************************
 *									*
 *	File:  tx_hostname.c						*
 *									*
 *	TranslateX HOSTNAME to internet address.			*
 *									*
 *	Written by Paul E. McKenney, SRI International.			*
 *									*
 ************************************************************************/
/* @(#)tx_hostname.c	1.1 92/12/26 */
/*
 *	$Log:	tx_hostname.c,v $
 * Revision 2.0  88/09/23  18:28:31  mckenney
 * .
 * 
 */

/* Include files.							*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <strings.h>

/* Type definitions local to this file.					*/

/* Functions exported from this file.					*/

extern int		tx_hostname();	/* TranslateX HOSTNAME.		*/

/* Functions local to this file.					*/

/* Variables exported from this file.					*/

/* Variables local to this file.					*/

/* TranslateX HOSTNAME to internet address (the 'X' is silent).		*/
/* Returns -1 if there was a system call problem, points em to a string	*/
/* containing the system call name.					*/
/* Returns -2 if there were other problems and points em to a		*/
/* string containing a human-readable error message.			*/
/* Returns host address in sa.						*/

extern int tx_hostname(host, sa, em)

	char		*host;		/* HOST name or id.		*/
	struct sockaddr_in *sa;		/* Socket Address.		*/
	char		**em;		/* Error Message pointer.	*/

	{
	char		errmsg[BUFSIZ];	/* ERRor MeSsaGe buffer.	*/
	struct hostent	*hp;		/* Host entry Pointer.		*/
	char		*rerrmsg;	/* Regex ERRor MeSsaGe.		*/

	char		*re_comp();	/* regex library routines. No	*/
	int		re_exec();	/* include files!!!!!!		*/

	/* Initialize socket address.					*/

	bzero((char *)sa, sizeof(*sa));
	sa->sin_family = AF_INET;

	/* Get host name -- check for internet address.			*/

	if ((rerrmsg =
	     re_comp("[0-9][0-9]*\\.[0-9][0-9]*\\.[0-9][0-9]*\\.[0-9][0-9]*"))
	     !=
	     (char *)0)
		{
		sprintf(errmsg, "re_comp error: %s\n", rerrmsg);
		*em = errmsg;
		return (-2);
		}
	if (re_exec(host) == 1)
		{
		u_long		inet_addr();	/* Kludge around C bug.	*/

		sa->sin_addr.s_addr = inet_addr(host);
		}
	else if ((hp = gethostbyname(host)) == NULL)
		{
		sprintf(errmsg, "\"%s\" not found in /etc/hosts!!\n", host);
		*em = errmsg;
		return (-2);
		}
	else
		sa->sin_addr.s_addr = *(u_long *)hp->h_addr;

	return (0);
	}
