
/*
 *******************************************************************************
 *
 *  commands.l
 *
 *	Andrew Cherenson	CS298-26  Fall 1985
 *
 *	Lex input file for the nslookup program command interpreter.
 *	When a sequence is recognized, the associated action
 *	routine is called. The action routine may need to
 *	parse the string for additional information.
 *
 *  Recognized commands: (identifiers are shown in uppercase)
 *
 *	server NAME	- set default server to NAME, using default server
 *				SetDefaultServer(yytext, 0);
 *
 *	lserver NAME	- set default server to NAME, using initial server
 *				SetDefaultServer(yytext, 1);
 *
 *	finger [NAME]	- finger the optional NAME
 *				Finger(yytext, 0);
 *				Finger(yytext, 1);
 *					     * 2nd arg.
 *					     *  0 == output to stdout
 *					     *  1 == output to file
 *
 *	exit		- exit the program
 *				return(0);
 *
 *	root		- set default server to the root
 *				SetDefaultServer(rootServerName, 1);
 *
 *	ls NAME		- list the domain NAME
 *				ListHosts(yytext, 0);
 *				ListHosts(yytext, 1);
 *					     * 2nd arg.
 *					     *  0 == output to stdout
 *					     *  1 == output to file
 *				ListHostsByType(yytext, 0);
 *				ListHostsByType(yytext, 1);
 *
 *	view FILE	- sorts and view the file with more
 *				ViewList(yytext);
 *
 *	set OPTION	- set an option
 *				SetOption(yytext);
 *
 *	help		- print help information
 *	?		- print help information
 *				PrintHelp();
 *
 *	NAME		- print info about the host/domain NAME
 *			  using default server.
 *				LookupHost(yytext, 0);
 *				LookupHost(yytext, 1);
 *					     * 0 == output to stdout
 *					     * 1 == output to file
 *
 *	NAME1 NAME2	- as above, but use NAME2 as server
 *				LookupHostWithServer(yytext, 0);
 *				LookupHostWithServer(yytext, 1);
 *					     * 0 == output to stdout
 *					     * 1 == output to file
 *
 *******************************************************************************
 */
