
/*
 *  dumpload.c	D.C.M.Wood 92/04/13
 *
 *  Dump and load data to/from history file
 */

#include <sys/file.h>
#include <sys/timeb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <time.h>

#include "data.h"

int	cc;
int	hash;
FILE *	hfp;
char	ipstr[20];
char	name[256];
struct NameAddr * nap;
int	pcnt;
char	when[20];


/*
 *  printNA
 *	Print Name/Addr Table entry
 */

printNA( f )
char f;
{
    struct tm * lt;

    strcpy( ipstr, inet_ntoa(  nap->addr ) );
/*
    lt = localtime( &(nap->CreationTime) );
    lt->tm_mon++;
    sprintf( when, "%02d/%02d/%02d %02d%02d",
			lt->tm_year,
			lt->tm_mon,
			lt->tm_mday,
			lt->tm_hour,
			lt->tm_min );
    cc = fprintf( hfp, "%-16s  %s  %s\n", ipstr, when, gfn( nap ) );
 */
    cc = fprintf( hfp, "%-16s  %s  %d %c\n", ipstr, gfn( nap ), hash, f );
    pcnt++;
    if ( cc < 0 )
	{
	perror( " Error writing dump file" );
	return;
	}
}


/*
 *  dumpht --
 *	Dump hash table data to disk
 */

dumpht()
{

    hfp = fopen( DUMPFILE, "w" );

    if (hfp == NULL )
	{
	perror( " Error opening dump file for writing" );
	return;
	}

/*
    for ( hash=0; hash<HASH_TABLE_SIZE; hash++ )
	if ( AddrHashTbl[hash] != NULL )
	    fprintf( hfp, "A %6d %6d\n", hash, AddrHashTbl[hash] );

    for ( hash=0; hash<HASH_TABLE_SIZE; hash++ )
        if ( NameHashTbl[hash] != NULL )
	    fprintf( hfp, "N %6d %6d\n", hash, NameHashTbl[hash] );
 */

    pcnt = 0;
    for ( nap=NAListp; nap != NULL; nap = nap->List )
	pcnt++;

    printf( " em_nsl: %d entries entries on list.\n", pcnt );

    pcnt = 0;
    for ( hash=0; hash<HASH_TABLE_SIZE; hash++ )
	{
	if ( AddrHashTbl[hash] != NULL )
	    for ( nap = AddrHashTbl[hash]; nap != NULL;
				nap->flags |= 1, nap = nap->Next )
		{
		if ( ( nap->flags & 1 ) == 1 )
		    continue;

		printNA( 'a' );
		}
	if ( NameHashTbl[hash] != NULL )
	    for ( nap = NameHashTbl[hash]; nap != NULL;
				nap->flags |= 1, nap = nap->Next )
		{
		if ( ( nap->flags & 1 ) == 1 )
		    continue;

		printNA( 'n' );
	        }
	}

    fclose( hfp );
    printf( " em_nsl: %d entries dumped.\n", pcnt );
    return;
}


/*
 *  loadht --
 *	Load hash table data from disk
 */

loadht()
{
u_long	addr;
int	cnt;
char	line[200];
time_t	seconds;
struct tm lt;

    lt.tm_sec = 0;

/*  Open the previous version of the dump file  */

    hfp = fopen( DUMPFILE, "r" );
    if (hfp == NULL )
	{
	perror( " Error opening load file for reading" );
	return;
	}

/*
 *<ip address>  <name> <time>
 */

    for ( cnt=0;; cnt++ )
	{
	cc = (int)fgets( line, 199, hfp );
	if( cc == NULL )
	    {
	    if ( cnt == 0 )
		perror( " Error at start of load" );
	    break;
	    }
/*
	cc = sscanf( line, "%s  %s %2d/%2d/%2d %2d%2d",
		    ipstr,
		    name,
		    &lt.tm_year,
		    &lt.tm_mon,
		    &lt.tm_mday,
		    &lt.tm_hour,
		    &lt.tm_min );

	if ( cc < 6 )
	    {
	    perror( " Error reading load file destination" );
	    continue;
	    }
	lt.tm_mon--;
	now = tm_to_time( &lt );
 */
	cc = sscanf( line, "%s  %s", ipstr, name );
	if ( cc < 2 )
	    {
	    perror( " Error reading load file destination" );
	    continue;
	    }
	addr = inet_addr( ipstr );
	(void)AddNATbl( name, addr );
	}

    fclose( hfp );
    printf( " em_nsl: %d entries created\n", cnt );
    return;
}
