/*
 *  getintf.c  DCM Wood	93/01/23
 */

#include <stdio.h>
#include <strings.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sockio.h>
#include <netdb.h>
#include <net/if.h>
#include <netinet/in.h>

#include "data.h"


/*
 *  GetIntf
 *	Get info for all interfaces on this system
 */

u_long
GetIntf()
{
    u_long  addr;
    int  cc;
    int  fd;
    struct hostent * hep;
    int  i;
    struct ifconf  ifc;
    struct ifreq   ifreq[20];
    struct ifreq * ifreqp;
    struct in_addr inaddr;
    struct in_addr inmask;
    char    netname[MAXHOSTNAMELEN];
    u_long  netmask;

    ifc.ifc_len = 20 * sizeof( struct ifreq );
    ifc.ifc_req = ifreq;

    /* Open a socket to do ioctls on.                           */

    if ( ( fd = socket( AF_INET, SOCK_DGRAM, 0 ) ) == -1 )
        {        
        perror( "socket" );
        return (-1);
        }               
                        
    /* Do the ioctl, check the result.                          */
                 
    if ( ioctl( fd, SIOCGIFCONF, &ifc) == -1 )
        {
        perror( "ioctl SIOCGIFCONF");
        close( fd );
        return (-1);
        } 

    if ( ifc.ifc_len/sizeof(struct ifreq) == 1 )
        if ( debug )
	    printf( " There is only one interface on this system\n" );
    else
        if ( debug )
	    printf( " There are %d interfaces on this system\n",
                                        ifc.ifc_len/sizeof(struct ifreq) );
    ifreqp = ifc.ifc_req;
    intfcnt = 0;
    for ( i=0; i<ifc.ifc_len; i+=sizeof( struct ifreq ), ifreqp++ )
        {
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inaddr.s_addr, 4 );
        if ( debug )
	    printf( " %s   %-16s", ifreqp->ifr_name, inet_ntoa( inaddr ) );
        if ( ioctl( fd, SIOCGIFNETMASK, ifreqp ) == -1 )
            {
            perror( "ioctl SIOCGIFNETMASK" );
            continue;
            }
        bcopy( &ifreqp->ifr_addr.sa_data[2], &inmask.s_addr, 4 );
        if ( debug )
	    printf( "   %-16s\n", inet_ntoa( inmask ) );
        if ( ( inaddr.s_addr & 0xff000000 ) == 0x7f000000 )
            continue;

	if ( IN_CLASSA( inaddr.s_addr ) )
	    netmask = IN_CLASSA_NET;
	else
	if ( IN_CLASSB( inaddr.s_addr ) )
	    netmask = IN_CLASSB_NET;
	else
	if ( IN_CLASSC( inaddr.s_addr ) )
	    netmask = IN_CLASSC_NET;
	else
	    netmask = 0;

	net_intf[intfcnt].addr = inaddr.s_addr;
	net_intf[intfcnt].smask = inmask.s_addr;
	net_intf[intfcnt].nmask = netmask;
	intfcnt++;

	netmask = MakeMask( inaddr.s_addr );
	inaddr.s_addr = inaddr.s_addr & netmask;

	MakeInAddr( inet_ntoa( inaddr ), netname );
	nep = AddNetEnt( inaddr.s_addr, inmask.s_addr, netname );
	if ( NetEnts == NULL )
	    {
	    NetEnts = LastNetEnt = nep;
	    CurNet.s_addr = inaddr.s_addr;
	    CurMask.s_addr = netmask;
	    IntfNetMask.s_addr = inmask.s_addr;
	    }
        }

    close( fd );
    return;
}

