
#ifndef lint
static char sccsid[] = "@(#)nslp2.c	5.39 (Berkeley) 6/24/90";
#endif /* not lint */

/*
 *   nslp2.c --
 *	nsl phase 2 - analyze the data
 */

#include <sys/param.h>
#include <sys/time.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pathnames.h"

#define MAIN
#include "data.h"


/*
 *  main --
 *	Load the dumped data and analyze it.
 */

main(argc, argv)
int	argc;
char	**argv;
{
    u_long	addr;
    u_long	mask;
    int		i;
    char	*wantedHost = NULL;
    char	reqHost[256];

    u_long  em_StartTime;
    struct timeval  tv;             /* Time for various uses  */
    struct timezone tz;             /* Time zone  */

    setlinebuf( stdout );
    gettimeofday( &tv, &tz);
    em_StartTime = tv.tv_sec;
    printf( " %s: started\n", argv[0] );


    /*
     * Parse the arguments:
     *	1 arg	=  network number to be looked up
     *  2nd arg	=  optional network mask
     *
     *	"Set" options are specified with a leading - and must come before
     *	any arguments. For example, to find the well-known services for
     *  a host, type "nsl -query=wks host"
     */

    ++argv; --argc;		/* skip prog name */

    if (argc > 2 ) {
	Usage();
    } 
    if (argc && *argv[0] != '-') {
	wantedHost = *argv;	/* name of net to be looked up */
	IsNet( wantedHost, &addr );
    }

    if ( argc == 2 )
	mask = inet_addr(*++argv);
    else
	mask = MakeMask( addr );

    dbgfp = fopen( DEBUGFILE, "w" );

    if (dbgfp == NULL )
	perror( " Error opening debug file for writing" );

    NAListp = NAListEndp = NULL;

    if ( wantedHost == NULL )
      GetIntf();
    else
      {
      MakeInAddr( wantedHost, reqHost );
      CurNet.s_addr = addr;
      CurMask.s_addr = mask;
/*
      nep = AddNetEnt( addr, mask, reqHost );
      NetEnts = nep;
      LastNetEnt = nep;
 */
      }

    loadht();
    findsm();
    findsn();
    findgw();
    sortnl();
/*  findss();  */
    findstr();
    UpdateJS();

    /*  Print statistics  */

    gettimeofday( &tv, &tz);
    printf( " \nStatistics:\n" );
    printf( " nslp2 took %d seconds\n", tv.tv_sec - em_StartTime );

    exit(0);
}


/*
 *  Usage --
 *	Lists the proper methods to run the program and exits.
 */

Usage()
{
    fprintf(stderr, "Usage:\n");
    fprintf(stderr,
"   nslp2 [-opt ...] net      # just look up 'net'\n");
    fprintf(stderr,
"   nslp2 [-opt ...] net mask # just look up 'net' assuming 'mask'\n");
    exit(1);
}


