/*
 *  updatejs.c	D.C.M.Wood 93/02/13
 *
 *  UpdateJS	Update the Journal Server
 */

#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <signal.h>

#define SOCKADDR_IN
#include "data_server.h"
#include "send_data.h"

#include "data.h"

/*
#ifndef PIN
#include "pin.h"
#endif

char	pin[20]= PIN;
*/
extern	char	pin[];

u_long	js_addr=0;			/* Journal server address */
u_long	js_port=DATA_PORT;		/* Journal Server port */


/*
 *  UpdateJS
 *	Update the Journal Server
 */

UpdateJS()
{
    struct Gateway * gwp;
    int     i;
    struct NameAddr * intfp;
    char    scrstr[20];
    int     sni;
    struct SubNetEnt * snp;
    int     jsfd;		/* Journal Server socket file descriptor */
    FILE *  jsfp;

    jsfd = getnetconnect( js_addr, js_port );
    jsfp = fdopen( jsfd, "w" );

    /*  Send subnet and interface info  */

    i = 0;
    for( sni=0; sni<MaxSubNets; sni++ )
	{
	if ( ( snp = *(SNP+sni) ) == NULL )
	    continue;

	i++;
	fprintf( jsfp, "NETWORK  %s\n", pin );

	strcpy( scrstr, inet_ntoa(  snp->addr ) );
	fprintf( jsfp, "NET_NUMB:\tAF_INET %s\n", scrstr );

	fprintf( jsfp, "\n\n" );

	if ( snp->ifcount < 1 )
	    continue;

	fprintf( jsfp, "INTF  %s\n", pin );

	strcpy( scrstr, inet_ntoa(  snp->LowIntf->addr ) );
	fprintf( jsfp, "PROT-ADDR:\tAF_INET %s\n", scrstr );

	fprintf( jsfp, "IN-NAME:\t%s.%s\n", snp->LowIntf->name,
					    snp->LowIntf->domain );

	fprintf( jsfp, "\n\n" );

	if ( snp->ifcount < 2 )
	    continue;

	fprintf( jsfp, "INTF  %s\n", pin );

	strcpy( scrstr, inet_ntoa(  snp->HighIntf->addr ) );
	fprintf( jsfp, "PROT-ADDR:\tAF_INET %s\n", scrstr );

	fprintf( jsfp, "IN-NAME:\t%s.%s\n", snp->HighIntf->name,
					    snp->HighIntf->domain );

	fprintf( jsfp, "\n\n" );
	}

    fprintf( stderr,
		" em_nsl:%4d NETWORK entries sent to Journal Server\n", i );

    /*  Send gateway info  */

    i = 0;
    for( gwp=gwpStart; gwp!=NULL; gwp=gwp->Next )
	{
	if ( gwp->intfcnt < 2 )
	    continue;

	i++;
	fprintf( jsfp, "GATEWAY  %s\n", pin );
	for ( intfp=gwp->intfFirst; intfp!=NULL; intfp=intfp->NextSameGW )
	    {
	    strcpy( scrstr, inet_ntoa(  intfp->addr ) );
	    fprintf( jsfp, "INTF:\tAF_INET %s\n", scrstr );
	    }
	fprintf( jsfp, "\n\n" );
	}
    fprintf( stderr,
		" em_nsl:%4d GATEWAY entries sent to Journal Server\n", i );

    i = 0;
    for( gwp=gwpStart; gwp!=NULL; gwp=gwp->Next )
	{
	if ( gwp->intfcnt < 2 )
	    continue;

	for ( intfp=gwp->intfFirst; intfp!=NULL; intfp=intfp->NextSameGW )
	    {
	    i++;
	    fprintf( jsfp, "INTF  %s\n", pin );
	    strcpy( scrstr, inet_ntoa(  intfp->addr ) );
	    fprintf( jsfp, "PROT-ADDR:\tAF_INET %s\n", scrstr );

	    fprintf( jsfp, "IN-NAME:\t%s.%s\n", intfp->name, intfp->domain );
	    fprintf( jsfp, "\n\n" );
	    }
	}
    fprintf( stderr,
		" em_nsl:%4d INTF entries sent to Journal Server\n", i );

    fclose( jsfp );
    return;
}

