
#ifndef lint
static char sccsid[] = "@(#)dest.c	5.22 (Berkeley) 8/3/90";
#endif /* not lint */

/*
 *  dest.c --
 *
 *	Miscellaneous subroutines for the trp program.
 */

#include <ctype.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>

#include "trp.h"


/*
 *  CreateDestEnt --
 *	Create a Destination Entry in the table
 */


DestP
CreateDestEnt( addr )
u_long	addr;
{
    struct Dest * dstp;

    DestCnt++;
    dstp = (struct Dest *)calloc( 1, sizeof( struct Dest) );
    dstp->CreationTime = now;
    dstp->addr.s_addr = addr;
    dstp->netmask.s_addr = MakeMask( addr );
    dstp->sm.s_addr = snmask.s_addr;
    dstp->TTL = 1;
    AddToPQ( dstp );
    return( dstp );
}


/*
 *  FindDest --
 *	Find a Destination Entry in the table
 */

DestP
FindDest( addr )
u_long	addr;
{
    struct Dest * dp;
    int	hash;

    addr &= snmask.s_addr;				/*  GROSS !!!  */
    hash = hash_addr( addr );

    if ( ( dp = DHT[hash] ) == NULL )
	return( NULL );

    for ( ; dp != NULL; dp = dp->SameHash )
	if ( dp->addr.s_addr == addr )
	    return( dp );

    return( NULL );
}


/*
 *  AddDestEnt --
 *	Add a Destination Entry in the table
 */

AddDestEnt( addr )
struct in_addr * addr;
{
    struct Dest ** ap;
    struct Dest * dp;
    int	hash;

    hash = hash_addr( addr->s_addr );

    ap = &DHT[hash];
    dp = *ap;

    while ( dp != NULL )
	{
	if ( dp->addr.s_addr == addr->s_addr )
	    {
	    fprintf( stderr, " Duplicate address = %s\n",
						inet_ntoa( addr ) );
	    return;
	    }

	ap = &(dp->SameHash);
	dp = dp->SameHash;
	}
    
    *ap = CreateDestEnt( addr->s_addr );
    return;
}

