/*
 *  network.c
 */

/*
 *	init_sockets	Initialize data and query sockets
 */

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>

#include "data_server.h"

/* @(#)network.c	1.1 9/27/92 */

extern	int	data_port;
extern	int	query_port;


void
init_sockets( socket_no )
int *	socket_no;
{
    int     cc;
    struct sockaddr_in * serv_addr;

    serv_addr = (struct sockaddr_in *) malloc(sizeof(struct sockaddr_in));
    if ( serv_addr == NULL )
	{
	fprintf( stderr,"js: Can't allocate memory for serv_addr\n");
	exit(1);
	}

    /* create socket for input data coming into the data server */

    socket_no[DATA_SOCK] = socket( AF_INET, SOCK_STREAM, 0 );
    if ( socket_no[DATA_SOCK] < 0 )
	{
	perror( "socket" );
	exit(1);
	}

    /* zero out the serv_addr structure */

    bzero( (char *) serv_addr, sizeof(*serv_addr) );

    /* set up serv_addr structure  for data input */

    serv_addr->sin_family = AF_INET;
    serv_addr->sin_addr.s_addr = htonl( INADDR_ANY );
    serv_addr->sin_port = htons( data_port );

    /* bind the address to the data sock */

    cc = bind( socket_no[DATA_SOCK], (struct sockaddr *) serv_addr,
							sizeof(*serv_addr) );
    if ( cc < 0)
	{
	perror( "bind" );
	exit(1);
	}

    /* set up a listen queue to accept input from various gathering programs */

    cc = listen( socket_no[DATA_SOCK], 5 );
    if ( cc < 0)
	{
	perror( "listen" );
	exit(1);
	}

    /* create socket for  query's */

    socket_no[QUERY_SOCK] = socket( AF_INET, SOCK_STREAM, 0 );
    if ( socket_no[QUERY_SOCK] < 0 )
	{
	perror( "socket" );
	exit(1);
	}

    /* zero out the serv addr structure */

    bzero( (char *) serv_addr, sizeof(*serv_addr) );

    /* set up the address structure for serv_addr */

    serv_addr->sin_family = AF_INET;
    serv_addr->sin_addr.s_addr = htonl( INADDR_ANY );
    serv_addr->sin_port = htons( query_port );

    /* bind the address to the socket */

    cc = bind( socket_no[QUERY_SOCK], (struct sockaddr *) serv_addr,
							sizeof(*serv_addr));
    if ( cc < 0 )
	{
	perror( "bind" );
	exit(1);
	}

    /* listen to socket to queue requests */

    cc = listen( socket_no[QUERY_SOCK], 5 );
    if ( cc < 0 )
	{
	perror( "listen" );
	exit(1);
	}
    return;
}

