#include<stdio.h>
#include"avl.h"
/* @(#)insert.c	1.1 11/1/92 */
struct avl_node *
insert(root,result,data,compare,data_node)
struct avl_node *root;
int *result;
char **data;
struct avl_node **data_node;
int (*compare)();
{
  int node_compare_result;
  int insert_result;
  struct avl_node *new_node;
  struct avl_node *balance();
  
	/* We currently have no tree  so it is not unbalanced */
  *result = 0;
  if(root == NULL)
  {
		/* create a new node for the tree */
    if((new_node= (struct avl_node *)malloc(sizeof(struct avl_node))) == NULL)
    {
      printf("can't allocate space for root\n");
      exit(-1);
    }
    
		/* zero out the leaf node */
		bzero(new_node,sizeof(struct avl_node));

		/* add data to the new_node leaf */
    new_node->node_data = *data;

		/* add or subtract 1 since we add a node to the tree */
    *result = 1;
		/* set the data_node to the new node since this is the data */
		*data_node = new_node;

		/* the new node is also the root in this situation */
    return(new_node);
  }
	/* Do a comparison on some data entry to determine where
	the next leaf goes into the tree */
  node_compare_result = (*compare)(root->node_data,*data);
	/* If the data item to be installed is less than the current leaf,
	go into the left child */
  if(node_compare_result < 0)
  {
		/* recursively decend the tree */
    root->left_child = insert(root->left_child,&insert_result,data,compare,data_node);	
		/* calculate the new height difference between 2 branches of a tree */
    root->height_diff = root->height_diff + (-1) * (insert_result);
    if(abs(root->height_diff)>1)
      root = balance(root,RIGHT);
    else
      root->left_child->parent = root;
    if(root->height_diff)
      *result = 1;

    return(root);
  }
	/* the right element of the tree gets the data */
  else if(node_compare_result >0)
  {
    root->right_child = insert(root->right_child,&insert_result,data,compare,data_node);
    root->height_diff = root->height_diff + insert_result;
    
    if(root->height_diff > 1)
      root = balance(root,LEFT);
    else
      root->right_child->parent = root;
    if(root->height_diff)
      *result = 1;

    return(root);
  }
  else
  {
		*data_node = root;
    return(root);
  }
}

