/*
**	list.h -- data independent header file for CS 2250 list package
*/
/*  @(#)list.h	1.2	10/5/91 */

struct list_node
{
	char  *datum;	/* pointer to data item */
	struct list_node *succ;		/* pointer to next item in list */
	struct list_node *pred;		/* pointer to previous item in list */

}; 		/* an entry in the list */


typedef struct list_head
{
	struct list_node	*list;		/* body of the list */
	struct list_node	*last;		/* last element in the list */
	unsigned long	length;		/* length of the list */
	int		(*cmp)();	/* compare function for data in list */
	void 		(*cpy)();	/* copy function for data in list */
	void 		(*print)();	/* print function for data in list */

}list_head;

