/*
** list_delete():
**	deletes element "what" from list "begin".
**
** pre:	 	assumes begin is a pointer to a valid list 
**		assumes 'what' is a pointer to a valid list element 
** post:	specified node is deleted from the list and its memory is
**		freed.
** @(#)list_delete.c	1.3  11/1/92
*/

#
#include "defs.h"
#include "data.h"
#include "list.h"
#


void list_delete(begin, what)
struct list_head 	 *begin;	/* pointer to valid list, or NULL */
struct list_node *what;	/* pointer to a valid list node, or NULL */
{
	/* Condition 1: Node is the first node in the list */
	if(what->pred == NULL)
	{
		begin->list = what->succ;
		if(what->succ)
			what->succ->pred = what->pred;
		else
			begin->last = NULL;
	}

	/* Condition 2: Node is at the end of the list */
	else if(what->succ == NULL)
	{
		what->pred->succ = what->succ;
		begin->last = what->pred;
	}

	/* Condition 3: Node is between two other nodes in a list */
	else
	{
		what->pred->succ = what->succ;
		what->succ->pred = what->pred;
	}

	/* free up the space that is being deleted */
	begin->length--;
	/* free( (void *)what); */

		
}
