/*
** list_fetch():
**	searches a list pointed to by 'begin' and returns a pointer
**	to the element containing 'datum' if that datum exists, else 
**	returns NULL.
**
** pre:	 begin points to the beginning of a valid list, or NULL
** post: returns the list emement which contains 'datum' or NULL if not found
**  @(#)list_fetch.c	1.2  2/9/90
*/
#include "defs.h"
#include "data.h"
#include "list.h"


LIST_NODE *list_fetch(begin,datum)
LIST	*begin;		/* pointer to beginning of list */
DATUM	*datum;		/* pointer to a datum to fetch */
{
	int count = 0; /* used to go through list and stop at end of list */
	LIST_NODE *temp; /* temporay node for looking at the data */


	/* check to make sure list exist and not empty */
	if(list_empty(begin))
	{
		return(NULL);
	}

	/* get the first node in the list */

	temp = begin->list;

	while(count < begin->length)
	{
		if(begin->cmp(datum,temp->datum) == 0)
		{
			return(temp);
		}

		temp = temp->succ;

		count++;
	}
	return(NULL);
}
