/* 
** list_init(): 
**	create a new list using user provided data manipulation functions
**
** pre:		cmp and cpy are compare and copy functions for the user's
**		data. compare returns -1, 0, or 1 for less than, equal, or
**		greater than respectively.  copy returns TRUE if the copy
**		was successful, FASLE otherwise.
** post:	returns pointer to the beginning of an empty list.
**		returns NULL if compare or copy function are bogus
**
** @(#)list_init.c	1.3   10/5/91
*/

#
#include <stdio.h>
#include "defs.h"
#include "data.h"
#include "list.h"
#
extern char *malloc();

char *list_init(cmp, cpy, print) 
int	(*cmp)();	/* compare function for list's data */
void	(*cpy)();	/* copy function for list's data */
void 	(*print)();	/* print function for list's data */
{
	list_head *header; /* pointer to a list structure for the head */

	/* create the memory for the header node */
	header = (list_head *) malloc(sizeof(struct list_head));
	if (header ==  NULL)
	{
		return(NULL);
	}

	/* initialize the various elements in header */
	header->list = NULL;
	header->last = NULL;

	/* initialize length of function to zero */
	header->length = 0;

	/* initialize the function pointers */
	header->cmp = cmp;
	header->cpy = cpy;
	header->print = print;

	/* return the header to the main program */

	return((char *)header);
}
