/* 
** list_print(): 
**	print out a list of things.
**
** pre:		begin points to the header node of a list.
**
** post:	If begin points to an empty list, print a message.
**		otherwise, the contents of each node in the list is 
**		printed to stdout.
**
**  @(#)list_print.c	1.3  11/11/91
*/

#
#include <stdio.h>
#include "defs.h"
#include "data.h"
#include "list.h"
#


/* list_print will print the entries in the linked lists */
void list_walk(begin,action)
struct list_head *begin;	/* pointer to header node of list */
void (*action)();
{
	struct list_node *temp;         /* node to be printed */
	int counter = 0;                /* counter used to find end of list */

	/* check to see if the list is empty */
	if(list_empty(begin))
	{
		return;
	}

	/* get the first node in the list */
	temp = begin->list;


	/* go through the linked lists printing each entry 
	in the list */
	while(counter < begin->length)
	{
		action(temp->datum);
		temp = temp->succ;
		counter++;
	}

}
