/*
 *  get_commands.c
 */

/*
 *  get_intf
 *  get_network
 *  get_gateway
 *  get_all
 *  get_ip
 *  get_eaddr
 *  get_conflicts
 *  get_stuff
 */


#include <stdio.h>

#include "data_server.h"

/* @(#)get_commands.c	1.2 1/10/93 */

extern struct data_list * first_node;

struct data_list *
get_intf( datahost )
char *	datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons( GET_INTF );
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data ,0);

    return( first_node );
}


struct data_list *
get_network(datahost)
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(GET_NETWORK);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data ,0);

    return( first_node );
}


struct data_list *
get_gateway(datahost)
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(GET_GW);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}


struct data_list *
get_all(datahost)
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(GET_ALL);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}


struct data_list *
get_ip(datahost)
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(GET_IPADDR);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}


struct data_list *
get_eaddr(datahost)
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(GET_EADDR);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}


struct data_list *
get_conflicts(type, datahost)
int     type;
char   *datahost;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons(type);
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}


struct data_list *
get_stuff( datahost, type )
char *	datahost;
int	type;
{
    int     datafd = -1;
    int     pack_data();
    int     n;
    char   *buf;

    buf = (char *) malloc(BUFSIZE);
    if ( buf == NULL )
	{
	printf( "get_stuff: Can't allocate memory for buf\n" );
	exit(1);
	}

    datafd = getnetconnect( datahost, QUERY_PORT );

    *((u_short *) (buf)) = htons( type );
    n = write( datafd, buf, sizeof(u_short) );
    get_data( datafd, pack_data,0 );

    return( first_node );
}

