/*
 *  pack_data.c
 */

#include <stdio.h>

#include "send_data.h"
#include "data_server.h"

/* @(#)pack_data.c	1.1 11/3/92 */

struct data_list *first_node = NULL;

/*
 * pack_data() is a routine  that takes data_record structure and
 * inserts it into a linked list which can be used to send all the
 * data to the data server
 */

pack_data( data )
struct data_record * data;
{
    static struct data_list * last_node = NULL;	/* last node in the list of
						   data */
    struct data_list * list_node;	/* head of linked list for data */

    /* get memory for a list of data records being sent to the data server */

    list_node = (struct data_list *) malloc(sizeof(struct data_list));
    if ( list_node == NULL )
	{
	printf("Unable to allocate memory for list_node\n");
	exit(0);
	}

    /* zero out the list item */

    bzero( list_node, sizeof(struct data_list) );

    /* check to see if the list exists currently,
    /*  if so, connect new node to the existing list of nodes */

    if ( first_node )
	{
	last_node->next = list_node;
	last_node = list_node;
	}

    /* set all nodes to just created node since this is the first one */

    else
	last_node = (struct data_list *) first_node = list_node;

    /* put pointer to the data into the node */

    last_node->data = data;
    return;
}

