/*
 *  send_data.c
 */

/*
 *  send_data
 *  ship_data
 */


#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <netdb.h>

#include "send_data.h"

/* %W% %G% */

/*
 * send_data takes a linked list of data and the name of the host
 * where the data server resides. The data_host can be set to NULL
 * and read the data server from another source
 */

FILE   *datafile;

int
send_data( data_host )
char  * data_host;		/* name of data host */
{
    char  * hostname;
    FILE  * dataserver_file;
    char  * data_file = NULL;
    struct sockaddr_in * server_addr = NULL;
    struct sockaddr_in * getaddr();
    void    ship_data();
    int     datafd = -1;

    /* check to see if the data host has been given, if so, get address  */

    if ( data_host && !strcmp(data_host, "stdout") ) 
	datafd = 1;

    /* check to see if it should write to a file */

    else if ( data_host && index(data_host, '/') )
	{
	data_file = (char *) malloc(strlen(data_host) + 1);
	if ( data_file == NULL )
	    {
	    printf( "data_file not allocated\n" );
	    exit(1);
	    }
	strcpy( data_file, data_host );
	datafd = open( data_file, O_WRONLY | O_CREAT | O_APPEND, 0644 );
	if ( datafd < 0 )
	    {
	    printf( "Can't open data_file %s\n", data_file );
	    return;
	    }
	}

    /* no / means not intended to be written to a file  */

    else
	{
	datafd = getnetconnect( data_host, DATA_PORT );
    	if ( datafd < 0 )
	    {
	    printf( "can't make net connection\n" );
	    exit(1);
	    }
	}

    /* send the data to the data server */

    if ( datafd > 0 )
	ship_data( datafd );

    close( datafd );
    return;
}


/*
 * function to send the data to the data server. Give it the
 * socket file descriptor and the data list to be sent
 */

void
ship_data( send_fd )
int     send_fd;		/* socket where data is to be sent */
{
    extern struct data_list * first_node;
    char    buf[BUF_SIZE];	/* buf to buffer output to data server */
    struct data_list * data_ptr = first_node;	/* pointer to parts of the
						   data */

    /* get a buffer i/o file descriptor for the data */

    datafile = fdopen( send_fd, "w" );

/*  setbuf( datafile,&buf ); */

    /* go through linked list of data and send it to the data server */

    while ( data_ptr )
	{
	struct data_list * data_list_tmp;	/* temporary data_list ptr to
						   free memory */

	write_data( data_ptr->data, 0,0 );
	data_list_tmp = data_ptr->next;
	/* free( data_ptr ); */
	data_ptr = data_list_tmp;
	}

    fclose( datafile );
    first_node = NULL;
    return;
}

